#include <stdio.h>
#include <stdlib.h>

#include <string.h>

int max_packing(int N, int m, int* numbers);

int main(int argc, char** argv)
{
	int i;
	int N, P;
	int m = argc - 2;
	int* numbers = (int *) malloc(m * sizeof(int) ); /* previously: too few! */
	
	N = atoi(argv[1]);

	for ( i = 0; i < m; i++ )
	{	
		numbers[i] = atoi(argv[i+2]);
	}

	P = max_packing(N, m, numbers);

	printf("Max packing = %d <= %d.\n", P, N);

	free(numbers);
	numbers = 0;

	return 0;
}


int* get_best_packing(int N, int m, int* numbers)
{
	int i,j;
	int sum1, sum2;
	int* packing1;
	int* packing2;
	int n;
	
	if ( m <= 0 )
	{
		return 0;
	}

	n= numbers[m-1];

	if ( m == 1 )
	{
		int* packing = (int*)malloc(1000 * sizeof(int));/* A DUMB FIX! */
		packing[0] = 0;
		packing[1] = 0;

		if ( n <= N )
		{
			packing[0] = n;
		}

		return packing;
	}

	if ( n > N )
	{
		return get_best_packing(N-n, m-1, numbers);
	}

	/* THIS PART ASSUMES n <= N */
	/* try WITH the element! */
	packing1 = get_best_packing(N-n, m-1, numbers);
	
	/* try WITHOUT the element! */
	packing2 = get_best_packing(N, m-1, numbers);

	sum1 = n;
	for ( i = 0; packing1[i] > 0; i++ )
	{
		sum1 += packing1[i];
	}

	sum2 = 0;
	for ( j = 0; packing2[j] > 0; j++ )
	{
		sum2 += packing2[j];
	}

	if ( sum1 > sum2 )
	{
		packing1[i] = n;
		packing1[i+1] = 0; /* add a terminating zero! */
	
		free(packing2);
		packing2 = 0;

		return packing1;
	}
	else
	{
		free(packing1);
		packing1 = 0;
		return packing2;
	}
}


int max_packing(int N, int m, int* numbers)
{
	/* USE DYNAMIC PROGRAMMING! */
	/* for all numbers to consider, see if we can pack the value into what we have! */
	int i, sum;
	int* packing = get_best_packing(N,m,numbers);

	sum = 0;
	for ( i = 0; packing[i] > 0; i++ )
	{
		sum += packing[i];
	}

	free(packing);
	packing = 0;
	return sum;
}

